module Proof where

import Term
import Rule
import TRS
import PCP

type Labeling a = [(Rule, a)]

type Diagram = (Peak, [Term])

type CritPairInfo = (Term, [Position], Term, Term, Maybe (Int, Int), [Term])

data CRProof = 
    EmptyTRS
  | CompositionalPcpRuleLabeling {
      _phi :: Labeling Int,
      _psi :: Labeling Int,
      _joinsRS :: [CritPairInfo],
      _joinsSR :: [CritPairInfo],
      _trsC :: TRS,
      _crProofForC :: CRProof
    }
  | CompositionalPcps {
      _trsR :: TRS, 
      _trsC :: TRS,
      _trsP :: TRS,
      _joinSequencesForC :: [CritPairInfo],
      _joinSequencesForR :: [CritPairInfo],
      _relativeTerminationProof :: SNProof,
      _crProofForC :: CRProof 
    }

type Fork = (Term, Rule, Position, Term, Rule, Term)

data CRDisproof = CapNotUnif Fork

data CRResult = CRProof CRProof | CRDisproof CRDisproof

type Interpretation = (String, [Int])

type Algebra = [Interpretation]

data SNProof = 
    RIsEmpty 
  | Linear Algebra
