module Proof2 where

-- import Term
-- import Rule
import TRS
-- import PCP
import Proof

type Interpretation = (String, [Int])

{-
type Algebra = [Interpretation]

data SNProof = 
    RIsEmpty 
  | Linear Algebra

type Labeling a = [(Rule, a)]

type Diagram = (Peak, [Term])

type CritPairInfo = (Term, [Position], Term, Term, Maybe (Int, Int), [Term])
-}


data Subproof =
    RL {
      __trsC :: TRS,
      __phi :: Labeling Int,
      __psi :: Labeling Int,
      __joinsRS :: [CritPairInfo],
      __joinsSR :: [CritPairInfo]
    }
  | CPS {
      __trsR :: TRS, 
      __trsP :: TRS,
      __trsC :: TRS,
      __joinSequencesForC :: [CritPairInfo],
      __joinSequencesForR :: [CritPairInfo],
      __relativeTerminationProof :: SNProof
    }

cr_proof :: [(Subproof, TRS)] -> CRProof
cr_proof [] = EmptyTRS
cr_proof ((r@(RL {}), trsC) : subproofs) =
  CompositionalPcpRuleLabeling {
      _trsC = trsC,
      _phi = __phi r,
      _psi = __psi r,
      _joinsRS = __joinsRS r,
      _joinsSR = __joinsSR r,
      _crProofForC = cr_proof subproofs
  }
cr_proof ((r@(CPS {}), trsC) : subproofs) =
  CompositionalPcps {
      _trsR = __trsR r,
      _trsC = trsC,
      _trsP = __trsP r,
      _joinSequencesForC = __joinSequencesForC r,
      _joinSequencesForR = __joinSequencesForR r,
      _relativeTerminationProof = __relativeTerminationProof r,
      _crProofForC = cr_proof subproofs
    }

from_cr_proof :: CRProof -> [(Subproof, TRS)]
from_cr_proof EmptyTRS = []
from_cr_proof r@(CompositionalPcpRuleLabeling {}) =
  (subproof, _trsC r) : from_cr_proof (_crProofForC r)
  where
    subproof = 
      RL {
        __trsC = _trsC r,
        __phi = _phi r,
        __psi = _psi r,
        __joinsRS = _joinsRS r,
        __joinsSR = _joinsSR r
      }
from_cr_proof r@(CompositionalPcps {}) =
  (subproof, _trsC r) : from_cr_proof (_crProofForC r)
  where
    subproof = 
      CPS {
        __trsR = _trsR r,
        __trsP = _trsP r,
        __trsC = _trsC r,
        __joinSequencesForC = _joinSequencesForC r,
        __joinSequencesForR = _joinSequencesForR r,
        __relativeTerminationProof = _relativeTerminationProof r
      }
